# This package still needs a lot of work -- avlmap has a horribly broken
# build system and there is some rpmlint output that *needs* to be fixed
# before this could be included in Fedora.

Name:           avlmap
Version:        0.12.4
Release:        1%{?dist}
Summary:        AVL balanced binary tree and mapping library
Group:          Development/Libraries
License:        LGPLv2+
URL:            http://avlmap.slashusr.org/
Source0:        http://avlmap.slashusr.org/download/avlmap-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)


%description
The avlmap library implements a data mapping abstraction in function
calls, along with an underlying AVL balanced binary search tree
implementation.

Features include:

* Each mapping may have a key type chosen from a variety of scalar,
string, and array types.

* Each mapping may have a mix of many data types from the same variety.

* Sequential access in addition to the usual indexed access, in both
forward and reverse directions.

* Duplicate mappings are supported by means of a separate insert function.

* Optional direct access to the underlying AVL binary tree implementation.


%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}


%description    devel
Development headers and libraries for %{name}.


%prep
%setup -q


%build
%configure
sed -i -e 's|-I-||g' \
       -e 's|-fgnu-linker||g' \
       -e 's|-fmove-all-movables||g' \
       build/Makefile
make


%install
rm -rf $RPM_BUILD_ROOT
# Project's configure/Makefile are horribly broken.
mkdir -p $RPM_BUILD_ROOT%{_includedir}
cp -a build/include/* $RPM_BUILD_ROOT%{_includedir}
mkdir -p $RPM_BUILD_ROOT%{_bindir}
pushd build/bin
for bin in *; do
  install -m 755 $bin $RPM_BUILD_ROOT%{_bindir}/%{name}-$bin
done
popd
mkdir -p $RPM_BUILD_ROOT%{_libdir}
pushd build/lib
for lib in *; do
  chmod 755 $lib
  cp -P $lib $RPM_BUILD_ROOT%{_libdir}/$lib
done
popd

# versioned .a archives? wtf?
rm -f $RPM_BUILD_ROOT%{_libdir}/libavlmap.a.*
# we don't want any .a archives anyways.
rm -f $RPM_BUILD_ROOT%{_libdir}/libavlmap.a

rm -f map/doc/build-html-1


%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig


%postun -p /sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc LICENSE README avl/doc map/doc
%{_bindir}/avlmap-*
%{_libdir}/libavlmap.so.*


%files devel
%defattr(-,root,root,-)
%{_includedir}/avlmap
%{_libdir}/libavlmap.so


%changelog
* Sun Jan 4 2008 Conrad Meyer <konrad@tylerc.org> - 0.12.4-1
- Initial package.
